'use strict';

Object.defineProperty(exports, '__esModule', {
  value: true
});
exports['default'] = traverse;

function traverse(node, visitor, parent) {
  if (!node) {
    return node;
  }

  var type = node.type;
  switch (type) {
    case 'Query':
      node.fields = node.fields.map(function (n) {
        return traverse(n, visitor, node);
      });
      break;

    case 'Field':
      node.params = node.params.map(function (n) {
        return traverse(n, visitor, node);
      });
      node.fields = node.fields.map(function (n) {
        return traverse(n, visitor, node);
      });
      break;

    case 'Argument':
      node.value = traverse(node.value, visitor, node);
      break;
  }

  if (typeof visitor[type] === 'function') {
    var repl = visitor[type](node, parent);
    if (repl !== void 0) {
      node = repl;
    }
  }

  return node;
}

module.exports = exports['default'];